MOUNT_NFS(8)

NAME
mount_nfs - mount NFS file systems

SYNOPSIS
mount_nfs [-23AbCcdilPpqsTUuX] [-a maxreadahead] [-D deadthresh] [-g maxgroups] [-I readdirsize] [-L leaseterm] [-o options] [-R retrycnt] [-r readsize] [-t timeout] [-w writesize] [-x retrans] rhost:path node

DESCRIPTION
The mount_nfs command calls the mount(2) system call to prepare and graft a remote NFS file system (rhost:path) on to the file system tree at the mount point node. The directory specified by node is converted to an absolute path before use. This command is normally executed by mount(8). It implements the mount protocol as described in RFC 1094, Appendix A and Appendix I.

The options are:

-2  Use the NFS Version 2 protocol.

-3  Use the NFS Version 3 protocol. The default is to try version 3 first, and fall back to version 2 if the mount fails.

-A  Disable the attribute cache in the client, making it consult the server for the current version of a given file's attributes every time the file is accessed.

    By default the attribute cache is enabled, making the client only consult the server every handful of seconds. This improves performance, however at the cost of the risk of a mid-air collision when changes are made simultaneously by different NFS clients and/or locally on the NFS server that affect the same file. In that case changes made elsewhere may be missed, leading to consistency issues.

-a maxreadahead
    Set the read-ahead count to the specified value. This may be in the range of 0 - 4, and determines how many blocks will be read ahead when a large file is being read sequentially. Trying a value greater than 1 for this is suggested for mounts with a large bandwidth * delay product.

-b  If an initial attempt to contact the server fails, fork off a child to keep trying the mount in the background. Useful for fstab(5), where the filesystem mount is not critical to multiuser operation.

-C  For UDP mount points, do a connect(2). Although this flag increases the efficiency of UDP mounts it cannot be used for servers that do not reply to requests from the standard NFS port number 2049, or for servers with multiple network interfaces. In these cases if the socket is connected and the server replies from a different port number or a different network interface the client will get ICMP port unreachable and the mount will hang.

-c  For UDP mount points, do not do a connect(2). This flag is deprecated and connectionless UDP mounts are the default.

-D deadthresh
    Set the “dead server threshold” to the specified number of round trip timeout intervals. After a “dead server threshold” of retransmit timeouts, “not responding” message is printed to a tty.

-d  Turn off the dynamic retransmit timeout estimator. This may be useful for UDP mounts that exhibit high retry rates, since it is possible that the dynamically estimated timeout interval is too short.

-g maxgroups
    Set the maximum size of the group list for the credentials to the specified value. This should be used for mounts on old servers that cannot handle a group list size of 16, as specified in RFC 1057. Try 8, if users in a lot of groups cannot get response from the mount point.

-I readdirsize
    Set the readdir read size to the specified value. The value should normally be a multiple of DIRBLKSIZ that is the read size for the mount.

-i  Make the mount interruptible, which implies that file system calls that are delayed due to an unresponsive server will fail with EINTR when a termination signal is posted for the process.

-L leaseterm
    Ignored. It used to be NQNFS lease term.

-l  Used with NFS Version 3 to specify that the ReaddirPlus() RPC should be used. This option reduces RPC traffic for cases such as ls -l, but tends to flood the attribute and name caches with prefetched entries. Try this option and see whether performance improves or degrades. Probably most useful for client to server network interconnects with a large bandwidth times delay product.

-o options
    Options are specified with a -o flag followed by a comma separated string of options. See the mount(8) man page for possible options and their meanings.

    The following NFS specific options are also available:

    bg  Same as -b.

    conn
        Same as -C.

    deadthresh=<deadthresh>
        Same as -D deadthresh.

    dumbtimer
        Same as -d.

    intr
        Same as -i.

    leaseterm=<leaseterm>
        Same as -L leaseterm.

    maxgrps=<maxgroups>
        Same as -g maxgroups.

    mntudp
        Same as -U.

    nfsv2
        Same as -2.

    nfsv3
        Same as -3.

    noac
        Same as -A.

    noresport
        Same as -p.

    nqnfs
        Same as -q.

    port=<portnumber>
        Use the specified port number for NFS requests. The default is to query the portmapper for the NFS port.

    rdirplus
        Same as -l.

    readahead=<maxreadahead>
        Same as -a maxreadahead.

    rsize=<readsize>
        Same as -r readsize.

    soft
        Same as -s.

    tcp Same as -T.

    udp Same as -u.

    timeo=<timeout>
        Same as -t timeout.

    wsize=<writesize>
        Same as -w writesize.

-P  Use a reserved socket port number. This is the default, and available for backwards compatibility purposes only.

-p  Do not use a reserved port number for RPCs. This option is provided only to be able to mimic the old default behavior of not using a reserved port, and should rarely be useful.

-q  A synonym of -3. It used to specify NQNFS.

-R retrycnt
    Set the retry count for doing the mount to the specified value. The default is 10000.

-r readsize
    Set the read data size to the specified value in bytes. It should normally be a power of 2 greater than or equal to 1024.

    This should be used for UDP mounts when the “fragments dropped after timeout” value is getting large while actively using a mount point. Use netstat(1) with the -s option to see what the “fragments dropped after timeout” value is. See the mount_nfs -w option also.

-s  A soft mount, which implies that file system calls will fail after retrans round trip timeout intervals.

-T  Use TCP transport instead of UDP. This is the default; the flag is maintained for backwards compatibility.

-t timeout
    Set the initial retransmit timeout to the specified value in 0.1 seconds. May be useful for fine tuning UDP mounts over internetworks with high packet loss rates or an overloaded server. Try increasing the interval if nfsstat(1) shows high retransmit rates while the file system is active or reducing the value if there is a low retransmit rate but long response delay observed. Normally, the -d option should be specified when using this option to manually tune the timeout interval. The default is 3 seconds.

-U  Force the mount protocol to use UDP transport, even for TCP NFS mounts. This is necessary for some old BSD servers.

-u  Use UDP transport instead of TCP. This may be necessary for some very old servers.

-w writesize
    Set the write data size to the specified value in bytes.

    The same logic applies for use of this option as with the mount_nfs -r option, but using the “fragments dropped after timeout” value on the NFS server instead of the client. Note that both the -r and -w options should only be used as a last ditch effort at improving performance when mounting servers that do not support TCP mounts.

-X  Perform 32 <-> 64 bit directory cookie translation for version 3 mounts. This may be needed in the case of a server using the upper 32 bits of version 3 directory cookies, and when you are running emulated binaries that access such a filesystem. Native NetBSD binaries will never need this option. This option introduces some overhead.

-x retrans
    Set the retransmit timeout count for soft mounts to the specified value. The default is 10.

EXAMPLES
The simplest way to invoke mount_nfs is with a command like:

    mount -t nfs remotehost:/filesystem /localmountpoint

It is also possible to automatically mount filesystems at boot from your /etc/fstab by using a line like:

    remotehost:/home /home nfs rw 0 0

PERFORMANCE
As can be derived from the comments accompanying the options, performance tuning of NFS can be a non-trivial task. Here are some common points to watch:

•   Increasing the read and write size with the -r and -w options respectively will increase throughput if the network interface can handle the larger packet sizes.

    The default size for NFS version 2 is 8K when using UDP, 64K when using TCP.

    The default size for NFS version 3 is platform dependent: on NetBSD/aarch64, NetBSD/amd64, and NetBSD/i386, the default is 32K, for other platforms it is 8K. Values over 32K are only supported for TCP, where 64K is the maximum.

    Any value over 32K is unlikely to get you more performance, unless you have a very fast network.

•   If the network interface cannot handle larger packet sizes or a long train of back to back packets, you may see low performance figures or even temporary hangups during NFS activity.

    This can especially happen with older Ethernet network interfaces. What happens is that either the receive buffer on the network interface on the client side is overflowing, or that similar events occur on the server, leading to a lot of dropped packets.

    In this case, decreasing the read and write size, using TCP, or a combination of both will usually lead to better throughput. Should you need to decrease the read and write size for all your NFS mounts because of a slow Ethernet network interface (e.g. a USB 1.1 to 10/100 Ethernet network interface), you can use

    options NFS_RSIZE=value
    options NFS_WSIZE=value

    in your kernel config(1) file to avoid having do specify the sizes for all mounts.

•   For connections that are not on the same LAN, and/or may experience packet loss, using TCP is strongly recommended.

ERRORS
Some common problems with mount_nfs can be difficult for first time users to understand.

    mount_nfs: can't access /foo: Permission denied

This message means that the remote host is either not exporting the filesystem you requested, or is not exporting it to your host. If you believe the remote host is indeed exporting a filesystem to you, make sure the exports(5) file is exporting the proper directories.

A common mistake is that mountd(8) will not export a filesystem with the -alldirs option, unless it is a mount point on the exporting host. It is not possible to remotely mount a subdirectory of an exported mount, unless it is exported with the -alldirs option.

The following error:

    NFS Portmap: RPC: Program not registered

means that the remote host is not running mountd(8). The program rpcinfo(8) can be used to determine if the remote host is running nfsd, and mountd by issuing the command:

    rpcinfo -p remotehostname

If the remote host is running nfsd, and mountd, it would display:

    100005    3   udp    719  mountd
    100005    1   tcp    720  mountd
    100005    3   tcp    720  mountd
    100003    2   udp   2049  nfs
    100003    3   udp   2049  nfs
    100003    2   tcp   2049  nfs
    100003    3   tcp   2049  nfs

The error:

    mount_nfs: can't get net id for host

indicates that mount_nfs cannot resolve the name of the remote host.

SEE ALSO
nfsstat(1), mount(2), unmount(2), options(4), exports(5), fstab(5), mount(8), mountd(8), rpcinfo(8) RFC 1094, March 1989, NFS: Network File System Protocol specification. RFC 2623, June 1999, NFS Version 2 and Version 3 Security Issues and the NFS Protocol's Use of RPCSEC_GCC and Kerberos V5. RFC 2624, June 1999, NFS Version 4 Design Considerations. RFC 2695, September 1999, Authentication Mechanisms for ONC RPC.

HISTORY
A version of the mount_nfs utility appeared in 4.4BSD.

CAVEATS
An NFS server should not mount its own exported file systems (loopback fashion) because doing so is fundamentally prone to deadlock.